//+------------------------------------------------------------------+
//|                                                  SimbaSystem.mq4 |
//|                                      Simba, programmed by Malcik |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright "Simba, programmed by Malcik"
#property link      "http://www.forex-tsd.com"

#define MAGICSS  20070129

extern int      MA_Type=1;             // 1 for SATL, 2 for HULL MA, 3 for JMA
extern int      JMA_HMA_Period=13;     // When using JMA or HMA, set period here
extern double   JMA_Phase=0;           // When using JMA, set phase here
extern bool     UseSATLFilter=true;    // When true, the EA will only go long/short when the price is above/below SATL (or any other MA)
extern bool     AllowReentries=false;  // When true, more than 1 position can be open (reentries at each 10 pips of better price or after retracement of W%R)
extern int      WPR_Period=90;         // W%R period
extern int      ChandDist_Min=35;      // Boundaries of distances of price from Chandelier
extern int      ChandDist_Max=100;     // Self explanatory
extern int      TPPips=355;            // Self explanatory
extern int      MaximumRisk=2;         // Integer number of percent of the account you want to risk per trade; if 0, no money management used

datetime LastMinute;
int      LongTrades=0;
int      ShortTrades=0;
double   LastBuyPrice=0;
double   LastSellPrice=0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   double SATL; //=iCustom(NULL,PERIOD_H4,"SATL",0,1);
   double SATL_Prev; //=iCustom(NULL,PERIOD_H4,"SATL",0,2);
   double Chandelier_Up=iCustom(NULL,PERIOD_H1,"ChandelierStops_v1",0,1);
   double Chandelier_Dn=iCustom(NULL,PERIOD_H1,"ChandelierStops_v1",1,1);
   double WPR=iWPR(NULL,0,WPR_Period,1);
   int    LotSize=1;
   int    res;
//----
   if(MA_Type==1)
     {
      SATL=iCustom(NULL,PERIOD_H4,"SATL",0,1);
      SATL_Prev=iCustom(NULL,PERIOD_H4,"SATL",0,2);
     }
   if(MA_Type==2)
     {
      SATL=iCustom(NULL,PERIOD_H4,"HMA",JMA_HMA_Period,0,1);
      SATL_Prev=iCustom(NULL,PERIOD_H4,"HMA",JMA_HMA_Period,0,2);
     }
   if(MA_Type==3)
     {
      SATL=iCustom(NULL,PERIOD_H4,"JMA",JMA_HMA_Period,JMA_Phase,0,1);
      SATL_Prev=iCustom(NULL,PERIOD_H4,"JMA",JMA_HMA_Period,JMA_Phase,0,2);
     }

   LongTrades=0;
   ShortTrades=0;

   if(OrdersTotal()>0)
   {
      for(int i=0;i<OrdersTotal();i++)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICSS)
           {
            if(OrderType()==OP_BUY)
              {
               if(SATL<SATL_Prev || (Chandelier_Up==EMPTY_VALUE && Chandelier_Dn!=EMPTY_VALUE))OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
              }
            if(OrderType()==OP_SELL)
              {
               if(SATL>SATL_Prev || (Chandelier_Up!=EMPTY_VALUE && Chandelier_Dn==EMPTY_VALUE))OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
              }
           }
        }

      for(i=0;i<OrdersTotal();i++)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICSS)
           {
            if(OrderType()==OP_BUY)
              {
               if(OrderStopLoss()<Chandelier_Up-Point)OrderModify(OrderTicket(),OrderOpenPrice(),Chandelier_Up-Point,OrderTakeProfit(),0,Green);
              }
            if(OrderType()==OP_SELL)
              {
               if(OrderStopLoss()>Chandelier_Dn+Point+Point*4)OrderModify(OrderTicket(),OrderOpenPrice(),Chandelier_Dn+Point+Point*4,OrderTakeProfit(),0,Green);
              }
           }
        }

      for(i=0;i<OrdersTotal();i++)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICSS)
           {
            if(OrderType()==OP_BUY)LongTrades++;
            if(OrderType()==OP_SELL)ShortTrades++;
           }
        }
     }

   if(LastMinute!=Time[0])
     {
      if(AllowReentries)
        {
         if(WPR>=-5)LongTrades=0;
         if(WPR<=-95)ShortTrades=0;
        }

      if(LongTrades==0 || (Close[0]<=LastBuyPrice-10*Point && AllowReentries))
        {
         if(SATL>SATL_Prev && (Close[0]>=SATL || !UseSATLFilter) && Chandelier_Up!=EMPTY_VALUE && Chandelier_Dn==EMPTY_VALUE && Close[0]>=Chandelier_Up+ChandDist_Min*Point && Close[0]<=Chandelier_Up+ChandDist_Max*Point && WPR<=-95)
           {
            if(MaximumRisk!=0)LotSize=NormalizeDouble((AccountFreeMargin()*MaximumRisk*0.01)/(((Ask-(Chandelier_Up-Point))/Point)*10),0);
            if(LotSize<=0)LotSize=1;
            Alert("LotSize=",LotSize);
            res=OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,Chandelier_Up-Point,Bid+(TPPips*Point),"SimbaSystemM1",MAGICSS,0,Green);
            LongTrades++;
            LastBuyPrice=Bid;
           }
        }

      if(ShortTrades==0 || (Close[0]>=LastSellPrice+10*Point && AllowReentries))
        {
         if(SATL<SATL_Prev && (Close[0]<=SATL || !UseSATLFilter) && Chandelier_Up==EMPTY_VALUE && Chandelier_Dn!=EMPTY_VALUE && Close[0]<=Chandelier_Dn-ChandDist_Min*Point && Close[0]>=Chandelier_Dn-ChandDist_Max*Point && WPR>=-5)
           {
            if(MaximumRisk!=0)LotSize=NormalizeDouble((AccountFreeMargin()*MaximumRisk*0.01)/((((Chandelier_Dn+Point+Point*4)-Bid)/Point)*10),0);
            if(LotSize<=0)LotSize=1;
            Alert("LotSize=",LotSize);
            res=OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,Chandelier_Dn+Point+Point*4,Ask-(TPPips*Point),"SimbaSystemM1",MAGICSS,0,Red);
            ShortTrades++;
            LastSellPrice=Bid;
           }
        }

      LastMinute=Time[0];
     }

//----
   return(0);
  }
//+------------------------------------------------------------------+